=== Tests/RunCMake/FindBoost/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
cmake_policy(SET CMP0167 OLD) # This test covers FindBoost
project(${RunCMake_TEST} NONE)
include(${RunCMake_TEST}.cmake)
